function CDR_isTrackedSpell(spellID)    
    if spellID == 19566 then
        CDR_AddSaltCooldown()
    else
        for key, value in pairs(CDR_SPELLS) do
            if key == spellID and key ~= 19566 then
                C_Timer.After(1, CDR_checkCharacterCooldown);
            end
        end
    end
end

function CDR_setTrack(SpellID)
    local char = UnitName("player"); 
    local name, rank, icon, castTime, minRange, maxRange, spellId = GetSpellInfo(spellID);
    local char_data = {
        ["character"] = char,
        ["data"] = {
            ["spellname"] = name,
            ["cooldown"] = 1
        }
    }
    if CDRDB_char == nil then
        CDRDB_char = {}
        table.insert( CDRDB_char, char_data )
    else
        local addit = true;
        for key, value in pairs(CDRDB_char) do
            if CDRDB_char[key]["character"] == char and CDRDB_char[key]["data"]["cooldown"] == 0 then
                CDRDB_char[key]["data"]["spellname"] = name;
                CDRDB_char[key]["data"]["cooldown"] = 1;
            elseif CDRDB_char[key]["character"] == char and CDRDB_char[key]["data"]["cooldown"] == 1 then
                addit = false;
            end
        end
        if addit then
            table.insert(CDRDB_char, char_data)
        end
    end
end

function CDR_AddSaltCooldown()    
    local time_server = GetServerTime();
    local spell_duration = 259200;
    local char = UnitName("player");  
    local data = {
        ["character"] = char,
        ["data"] = {
            ["spellname"] = "Salt Shaker",
            ["spellid"] = 19566,
            ["start"] = time_server,
            ["start_hardware"] = nil,
            ["duration"] = spell_duration,
            ["expected"] = time_server + spell_duration,
            ["active"] = 1,
        }
    }

    local isAdded = false;
    if CDRDB == nil then
        CDRDB = {}
    else
        for key, value in pairs(CDRDB) do
            if CDRDB[key]["character"] == char and (CDRDB[key]["data"]["spellname"] == "Salt Shaker" or CDRDB[key]["data"]["spellid"] == 19566)  then
                isAdded = true;
                CDRDB[key]["data"]["expected"] = time_server + spell_duration;
                CDRDB[key]["data"]["active"] = 1;
                CDRDB[key]["data"]["start"] = time_server;
            end
        end
    end 
    
    if not isAdded then
        table.insert(CDRDB, data)
    end
    print("|cff00ff00 === CooldownReminder Salt cooldown registred ===")
end

function CDR_setJobCD(spellID)
    local start, duration, enabled = GetSpellCooldown(spellID);
    local time_server = GetServerTime();
    local name, rank, icon, castTime, minRange, maxRange, spellId = GetSpellInfo(spellID);
    local char = UnitName("player");  
    local data = {
        ["character"] = char,
        ["data"] = {
            ["spellname"] = name,
            ["spellid"] = spellID,
            ["start"] = time_server,
            ["start_hardware"] = start,
            ["duration"] = duration,
            ["expected"] = start + duration,
            ["active"] = 1,
        }
    }
        
    if CDRDB == nil then
        CDRDB = {}
    end 
    table.insert(CDRDB, data)
    print("|cff00ff00 === CooldownReminder new CD listed for its basic cooldown ===")
    print("|cffff0000 === Open your tradeskill to correctly update the cooldown.("..name..") ===")
end

function CDR_loginRoutine()
    print("CDR_ Type /cdr help for more informations.");
    CDR_checkCharacterCooldown()
    CDR_printCDRData()
end

function CDR_checkCharacterCooldown()
    local alchemy = false;
    for key, value in pairs(CDR_SPELLS) do
        local start, duration, enabled = GetSpellCooldown(tonumber(key));
        if start > 0 then            
            if not (CDR_SPELLS[key]["Type"] == "Transmute") then
                print('CDR-Check, cooldown detected: ' .. value["name"])
                CDR_addToList(key)
                CDR_setTrack(key)
            elseif CDR_SPELLS[key]["Type"] == "Transmute" and alchemy == false then
                print('CDR-Check, cooldown detected: ' .. value["name"])
                CDR_addToList(key)
                CDR_setTrack(key)
                alchemy = true;
            end
        end
    end
    if IsSpellKnown(11611) then
        for i = 1, 2 do
            CastSpellByName('Alchemy')            
        end
    end
    if IsSpellKnown(12180) then
        for i = 1, 2 do
            CastSpellByName('Tailoring')
        end
    end
end

function CDR_addToList(spellID)
    if CDRDB then
        local char = UnitName("player");
        local elementExist = false;
        for key, value in pairs(CDRDB) do
            if CDRDB[key]["data"]["spellid"] == spellID and CDRDB[key]["character"] == char and CDRDB[key]["data"]["active"] == 1 then
                elementExist = true
            end
        end
        if not elementExist then
            CDR_setJobCD(spellID)
        end
    else
        CDR_setJobCD(spellID)
    end
end

function  CDR_reset()
    CDRDB = {};
    CDRDB_char = {};
    CDR_checkCharacterCooldown()
    print("|cffff0000 === CooldownRemind Reset ===");
    CDR_printCDRData()
end

function CDR_TradeSkillCoolDownControl()
    for i=1, GetNumTradeSkills() do
        spellname, kind, _, open = GetTradeSkillInfo(i);
        name, rank, icon, castTime, minRange, maxRange, spellId = GetSpellInfo(spellname)
        if kind ~= "header" then
            for key, value in pairs(CDR_SPELLS) do
                if (CDR_SPELLS[key]["name"] == spellname or CDR_SPELLS[key]["name_fr"] == spellname or key == spellId) then
                    local skillCD = GetTradeSkillCooldown(i)
                    if skillCD ~= nil then
                        skillCD = math.floor(skillCD+0.5); --Used to round
                        CDR_validateSkillCooldown(skillCD, spellname, key)
                    end
                end
            end
        end
    end
end

function CDR_validateSkillCooldown(remaining, spellname, spellID)
    local char = UnitName("player");
    if CDRDB ~= nil then
        for key, DB_Value in pairs(CDRDB) do
            if (CDRDB[key]["character"] == char and CDRDB[key]["data"]["spellname"] == spellname and CDRDB[key]["data"]["active"] == 0) or
                (CDRDB[key]["character"] == char and (CDR_IsTransmute(CDRDB[key]["data"]["spellname"]) and CDR_IsTransmute(spellname))and CDRDB[key]["data"]["active"] == 0)
            then
                CDR_resetCDFromBook(remaining, key, spellID)
            elseif (CDRDB[key]["character"] == char and CDRDB[key]["data"]["spellname"] == spellname and CDRDB[key]["data"]["active"] == 1) or
            (CDRDB[key]["character"] == char and (CDR_IsTransmute(CDRDB[key]["data"]["spellname"]) and CDR_IsTransmute(spellname))and CDRDB[key]["data"]["active"] == 1)
            then
                CDR_valideCDFromBook(spellID, remaining, key)
            end
        end
    else
        CDR_setCDFromBook(spellname, spellID, skillCD)
    end
end

function CDR_IsTransmute(text)
    if string.match(text, "Transmute") or string.match(text, "Transmutation") then 
        return true;
    else
        return false;
    end
end

function CDR_valideCDFromBook(spellID, skillCD, index)
    local start, duration, enabled = GetSpellCooldown(spellID);
    local time_server = GetServerTime();

    if skillCD < duration then
        time_server = time_server - (duration-skillCD);
    end

    local origin = CDRDB[index]["data"]["start"];

    if origin > time_server then
        if (origin - time_server) < 60 then
            return;
        end
    else
        if(time_server - origin) < 60 then
            return;
        end
    end

    CDRDB[index]["data"]["start"] = time_server;
    print("|cff00ff00 === CooldownReminder: CD update (Logout to save it) ===")
    
end

function CDR_resetCDFromBook(skillCD, index, spellID)
    local start, duration, enabled = GetSpellCooldown(spellID);
    local time_server = GetServerTime();

    if skillCD < duration then
        time_server = time_server - (duration-skillCD);
    end

    CDRDB[index]["data"]["start"] = time_server;
    CDRDB[index]["data"]["expected"] = start + duration;
    CDRDB[index]["data"]["active"] = 1;
    
    print("|cff00ff00 === CooldownReminder new CD listed ===")
end

function CDR_setCDFromBook(spellname, spellID, skillCD)
    local start, duration, enabled = GetSpellCooldown(spellID);
    local time_server = GetServerTime();

    if skillCD < duration then
        time_server = time_server - (duration-skillCD);
    end    
    
    local name, rank, icon, castTime, minRange, maxRange, spellId = GetSpellInfo(spellname);
    local char = UnitName("player");  
    local data = {
        ["character"] = char,
        ["data"] = {
            ["spellname"] = name,
            ["spellid"] = spellID,
            ["start"] = time_server,
            ["start_hardware"] = start,
            ["duration"] = duration,
            ["expected"] = start + duration,
            ["active"] = 1,
        }
    }
        
    if CDRDB == nil then
        CDRDB = {}
    end 
    table.insert(CDRDB, data)
    print(skillCD)
    print("|cff00ff00 === CooldownReminder new CD listed ===")
end


function CDR_getCooldown(start, cooldown)
    --seconds
    local current = GetServerTime();
    local day = 0;
    local hour = 0;
    local minute = 0;
    local second = 0;
    local rday, rhour, rminute, rsecond;
    local SCD_PER_DAY = 86400;
    local SCD_PER_HOUR = 3600;
    local SCD_PER_MINUTE = 60;
    if start > 0 and cooldown > 0 then
        if (current - start) < cooldown then
            remaining = (start+cooldown) - current;
            rday = math.floor(remaining / SCD_PER_DAY);
            if rday > 0 then
                day = rday;
                remaining = remaining - (SCD_PER_DAY*day);
            end
            rhour = math.floor(remaining/SCD_PER_HOUR);
            if rhour > 0 then
                hour = rhour;
                remaining = remaining - (SCD_PER_HOUR*hour);
            end
            rminute = math.floor(remaining/SCD_PER_MINUTE);
            if rminute > 0 then
                minute = rminute;
                remaining = remaining - (SCD_PER_MINUTE*minute);
            end
            if day == 0 and hour < 3 then
                return "|cffff0000 Available soon: "..hour.."h "..minute.."min";
            elseif day >= 1 and hour >= 12 then
                return "|cff00ff00 Long: "..day.."d "..hour.."h "..minute.."min";
            else
                return day.."d "..hour.."h "..minute.."min";
            end
        end
    else
        return false
    end
end

function CDR_SetCustomCooldown(data)
    local delimiter = {"d","h","m"};
    local newData = {};
    local count = 0;

    for i=1, 3 do
        newData[i] = CDR_Split(data, delimiter[i])
        data = newData[i][2];
        if newData[i] ~= nil and newData[i][1] ~= nil then
            if newData[i][1] >= 0 then
                count = count + 1;
            else
                print('--- CDR Parse error --- \n invalid data('..delimiter[i]..')')
                return;
            end
        else
            print('--- CDR Parse error --- \n invalid data('..delimiter[i]..', nil)')
            return;
        end        
    end

    if count == 3 then
        CDR_SetCustomData(newData)
    end
    
end

function CDR_SetCustomData(data)
    --data = [day, hours, min]
    local remaining_time = CDR_GetMS(data[1][1], 'd') + CDR_GetMS(data[2][1], 'h') + CDR_GetMS(data[3][1], 'm');

    local time_server = GetServerTime();
    local spell_duration = 259200;

    if remaining_time > spell_duration then
        print('Invalid cooldown')
        return;
    end    

    local estimated_time = time_server - (spell_duration - remaining_time);

    local char = UnitName("player");  
    local data = {
        ["character"] = char,
        ["data"] = {
            ["spellname"] = "Salt Shaker",
            ["spellid"] = 19566,
            ["start"] = estimated_time,
            ["start_hardware"] = nil,
            ["duration"] = spell_duration,
            ["expected"] = estimated_time + spell_duration,
            ["active"] = 1,
        }
    }

    if CDRDB == nil then
        CDRDB = {}
    else
        for key, value in pairs(CDRDB) do
            if CDRDB[key]["character"] == char and (CDRDB[key]["data"]["spellname"] == "Salt Shaker" or CDRDB[key]["data"]["spellid"] == 19566)  then
                isAdded = true;
                CDRDB[key]["data"]["expected"] = estimated_time + spell_duration;
                CDRDB[key]["data"]["active"] = 1;
                CDRDB[key]["data"]["start"] = estimated_time;
            end
        end
    end 
    
    table.insert(CDRDB, data)
    print("|cff00ff00 === CooldownReminder Salt cooldown registred ===")
end

function CDR_GetMS(time, type)
    if time > 0 then
        if type == 'd' then
            local scd_per_day = 86400;
            return time * scd_per_day;
        elseif type == 'h' then
            local scd_per_hour = 3600;
            return time * scd_per_hour;
        elseif type == 'm' then
            local scd_per_min = 60;
            return time * scd_per_min;
        end
    else
        return 0
    end
end

function CDR_Split(str, delimiter)
    local regex = "(.-)"..delimiter;
    local data = nil;
    for w in str:gmatch(regex) do 
        data = tonumber(w);
        str = string.sub(str, string.find(str, delimiter) + 1)
    end
    return {data, str};
end

function CDR_deleteCooldown(id)
    local key = tonumber(id);
    if key <= 0 then
        return;
    end
    if CDRDB[key] ~= nil then
        table.remove(CDRDB,key)
        print("|cff00ff00 === CooldownReminder Item delete, logout to save new data ===")
    else
        print("|cff00ff00 === CooldownReminder Invalid ID ===")
    end    
end